LeetCode - construct-binary-tree-from-inorder-and-postorder-traversal

2024-04-20 06:58

本文主要是介绍LeetCode - construct-binary-tree-from-inorder-and-postorder-traversal,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目:

Given inorder and postorder traversal of a tree, construct the binary tree.

Note: 
You may assume that duplicates do not exist in the tree.

 

题意:

给你一个二叉树的中序序列和后序序列,确定二叉树。

里面的结点不重复

 

解题思路:

由后序序列确定根节点

在中序序列中找到根节点,将其左右分为左右子树

递归连接左右子树,最终构造二叉树

 

代码:

public TreeNode buildTree(int[] inorder, int[] postorder) {if(inorder.length <= 0 || postorder.length <= 0) {return null;}return getTree(inorder,0,inorder.length-1,postorder,0,postorder.length-1);}public TreeNode getTree(int[] inorder, int ins, int ine, int[] postorder, int posts, int poste) {if(ins > ine || posts > poste) {return null;}//从后序遍历获取根节点,也就是后序遍历的最后一个结点TreeNode root = new TreeNode(postorder[poste]);//根据根节点在中序遍历中将其分开为左右子树for(int i = ins ;i <= ine ; i++) {if(inorder[i] == postorder[poste]) {root.left = getTree(inorder,ins,i-1,postorder,posts,posts+i-ins-1);root.right = getTree(inorder,i+1,ine,postorder,posts+i-ins,poste-1);}}return root;}

 

这里面难点在于左右子树的范围难以确定,我现在给出一个具体例子来解释左右子树范围确定

ins 是中序序列inorder的起始位置,ine是终点

posts是后序序列postorder的起始位置,poste是终点

中序序列:ABCDEFG

后序序列:BDCAFGE

根据后序序列 确定E是树的根节点

在中序序列找到E的位置,所以左子树为ABCD,右子树为FG

此时后序序列也把其分为左右子树,左子树为BDCA,右子树为FGE

 

先递归左子树:

root.left = getTree(inorder,ins,i-1,postorder,posts,posts+i-ins-1);

先看看中序序列的左子树:

ins刚开始index为0,i也就是E的index为4,i-1=3也就是D的index ,所以遍历的范围就是(ABCD)

后序序列的左子树:

posts index为0 ,posts+i-ins-1, i-ins是代表中序序列中根节点的左子树长度,也就是4-0=4 ,posts+i-ins-1为0+4-1=3,也就是A的位置,这里遍历的范围是(BDCA)

 

递归右子树:

root.right = getTree(inorder,i+1,ine,postorder,posts+i-ins,poste-1);

中序序列的右子树:

i+1,也就是4+1=5,F的位置,ine为inorder.length-1=6,刚好在G的位置,所以右子树遍历就是在(FG)里面

后序序列的左子树:

起始点为posts+i-ins 也就是 0+4-0 =4 ,也就是F的位置, 终点为poste-1 = 6-1=5也就是G的位置,这里减1是因为E已经作为根节点移出去了,所以它的右子树只有(FG)

 

 

第一步就是这样的,后面就可以通过递归来不断完善这颗二叉树,所以后面就没写出来了。希望能帮助大家理解这里递归参数的意思。

这篇关于LeetCode - construct-binary-tree-from-inorder-and-postorder-traversal的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/919579

相关文章

哈希leetcode-1

目录 1前言 2.例题  2.1两数之和 2.2判断是否互为字符重排 2.3存在重复元素1 2.4存在重复元素2 2.5字母异位词分组 1前言 哈希表主要是适合于快速查找某个元素(O(1)) 当我们要频繁的查找某个元素,第一哈希表O(1),第二,二分O(log n) 一般可以分为语言自带的容器哈希和用数组模拟的简易哈希。 最简单的比如数组模拟字符存储,只要开26个c

uva 575 Skew Binary(位运算)

求第一个以(2^(k+1)-1)为进制的数。 数据不大,可以直接搞。 代码: #include <stdio.h>#include <string.h>const int maxn = 100 + 5;int main(){char num[maxn];while (scanf("%s", num) == 1){if (num[0] == '0')break;int len =

leetcode-24Swap Nodes in Pairs

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode swapPairs(L

leetcode-23Merge k Sorted Lists

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode mergeKLists

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟)

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟) 题目描述 给定一个链表,链表中的每个节点代表一个整数。链表中的整数由 0 分隔开,表示不同的区间。链表的开始和结束节点的值都为 0。任务是将每两个相邻的 0 之间的所有节点合并成一个节点,新节点的值为原区间内所有节点值的和。合并后,需要移除所有的 0,并返回修改后的链表头节点。 思路分析 初始化:创建一个虚拟头节点

C语言 | Leetcode C语言题解之第393题UTF-8编码验证

题目: 题解: static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num & MASK1) == 0) {return

【JavaScript】LeetCode:16-20

文章目录 16 无重复字符的最长字串17 找到字符串中所有字母异位词18 和为K的子数组19 滑动窗口最大值20 最小覆盖字串 16 无重复字符的最长字串 滑动窗口 + 哈希表这里用哈希集合Set()实现。左指针i,右指针j,从头遍历数组,若j指针指向的元素不在set中,则加入该元素,否则更新结果res,删除集合中i指针指向的元素,进入下一轮循环。 /*** @param

树(Tree)——《啊哈!算法》

树 什么是树?树是一种特殊的图,不包含回路的连通无向树。 正因为树有着“不包含回路”这个特点,所以树就被赋予了很多特性。 一棵树中的任意两个结点有且仅有唯一的一条路径连通。一棵树如果有n个结点,那么它一定恰好有n-1条边。在一棵树中加一条边将会构成一个回路。 一棵树有且只有一个根结点。 没有父结点的结点称为根结点(祖先)。没有子结点的结点称为叶结点。如果一个结点既不是根结点也不是叶

LeetCode:64. 最大正方形 动态规划 时间复杂度O(nm)

64. 最大正方形 题目链接 题目描述 给定一个由 0 和 1 组成的二维矩阵,找出只包含 1 的最大正方形,并返回其面积。 示例1: 输入: 1 0 1 0 01 0 1 1 11 1 1 1 11 0 0 1 0输出: 4 示例2: 输入: 0 1 1 0 01 1 1 1 11 1 1 1 11 1 1 1 1输出: 9 解题思路 这道题的思路是使用动态规划